/////////////////////////////////////////////////////////////////
//Henon Map als Fraktal  - Kapitel Fraktale
//////////////////////////////////////////////////////////////

//Die beiden wesentlichen Parameter c1 und c2
float c1 = 1.4;
float c2 = 0.3;
//Bildausschnitt zu Beginn:
float xU =-1.5; float xO =1.5;
float yU = -0.4; float yO = 0.4;
//Einige Zwischenspeicher:
float xNeuF, yNeuF, xUNeu, xONeu, yUNeu, yONeu;
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, muss man mit double-Werten rechnen
double xAlt, yAlt, xNeu, yNeu; 
boolean fluchtBereich;

int w,h;
int n, i, j, xK, yK;
color[] farben = {color(255,0,0),color(0,180,0),color(0,0,255),color(255,0,255),color(0,255,255),color(0,0,0)};                   ;
double d;
String s;

int tastenH = 50;
int anzahlT;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
char[] tBeschriftung;
PFont font;


//Initialisierungen  
void setup(){ 
  size(800, 800);
  background(255);
  tastenEinstellungen();
  w = width; h = height;
  fill(0);// textSize(12);
  smooth();
  n= 50000; i=0; j=0;
  xAlt = 0; yAlt = 0;
  xUNeu = 0; xONeu = 0;
  yUNeu = 0; yUNeu = 0;
  fluchtBereich = false;
  iteriere(xAlt,yAlt,n);
}
 
 void draw(){
   tastenZeichnen(); 
 //Fluchtbereich zeichnen
   if(fluchtBereich){
     for(int l = 1; l<=w; l++){
       for(int s =1; s<=h; s++){
         xAlt = map(l,0,w,xU,xO);
         yAlt = map(s,0,h, yO,yU);
         for(int k =0; k <= 100; k++){
           xNeu = yAlt+1-c1*xAlt*xAlt;
           yNeu = c2*xAlt; 
           xAlt = xNeu; yAlt = yNeu;
        }
        d = Math.sqrt(xAlt*xAlt + yAlt*yAlt);
        if(d<= 1000){stroke(255,255,0,90); point(l,s);
        }else{stroke(0,0,255); point(l,s);}
       }   
     }     
    fluchtBereich = false;  
    xAlt=0; yAlt=0;
 }
}
//////////////////////////////////////
//

void keyPressed(){  
  if (key == ENTER){  
     fluchtBereich = true; 
  } 
  //zehnfach Iteration "von Hand" ausgelöst
  //falls die Punkte zu wenig dicht liegen
  if (key == TAB){  
    for(int q = 0; q <=10; q++){
     iteriere(xAlt,yAlt,n);    
    }
    println("x = "+xAlt+"  y = "+yAlt);//nur zur Kontrolle  
  }  
  if (key == '1'){  //vergrößern c1
    i =0; xAlt = 0; yAlt=0;
    c1=c1+0.002;
    j = (j+1) % 6; //um die Farbe zu wechseln
    iteriere(0,0,n);
  }
  if (key == '2'){  //vergrößern c2
    i =0; xAlt = 0; yAlt=0;
    c2=c2+0.002;
    j = (j+1) % 6;
    iteriere(0,0,n);
  }
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  
  if(mouseY < height-tastenH){
    background(255);
    xAlt =0; yAlt =0;i=0;
     
    if(mouseButton==LEFT){
      xUNeu = map(mouseX,0,w,xU,xO)-(xO-xU)/10;
      xONeu = map(mouseX,0,w,xU,xO)+(xO-xU)/10;
      yUNeu = map(mouseY,0,h, yO,yU)-(yO-yU)/10;
      yONeu = map(mouseY,0,h, yO,yU)+(yO-yU)/10;
      xU = xUNeu; xO = xONeu; yU = yUNeu; yO = yONeu;
      j = (j+1) % 6;//um die Farbe zu wechseln   
    }
     if(mouseButton==RIGHT){  
        n*=2;      
     }
      iteriere(xAlt,yAlt,n); 
  }else{
      int ort = int(mouseX/(tastenH));//println(ort);
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
      switch(ort){
        
      case 0://'F'   
         tasteAktiv[0]=true;
         fluchtBereich = true; 
      break;
      
      case 1: //'n'   
       tasteAktiv[1]=true;
       for(int q = 0; q <=10; q++){
          iteriere(xAlt,yAlt,n);    
       }
      break;
      
      case 2://'c'
       tasteAktiv[2]=true;
       i =0; 
       c1=c1+0.002;
       j = (j+1) % 6; //um die Farbe zu wechseln
       iteriere(0,0,n);
      
      break;
      
      case 3://'d'
       tasteAktiv[3]=true;
       i =0; 
       c2=c2+0.002;
       j = (j+1) % 6;
       iteriere(0,0,n);
      
      break;
      
      case 4://'R'
       tasteAktiv[4]=true;
       i =0; 
       c1 = 1.4;c2 = 0.3;
       xU =-1.5; xO =1.5;
       yU = -0.4; yO = 0.4;
       j = (j+1) % 6;
       background(255);
       iteriere(0,0,n);
      
      break;
      
      default:
        background(200);
        println("Keine Aktion");
        break;
  }
 }
}
//////////////////////////////////////////////////////////
//Eine erste Iteration wird im setup() ausgelöst
//Durch drücken der Tab-Taste können weitere Iterationen 
//angefordert werden
////////////////////////////////////////////////////////
void iteriere(double XAlt, double YAlt, int N){  
   xAlt = XAlt;
   yAlt = YAlt;
   this.n =   N;
   while(i <=n){
     xNeu = yAlt+1-c1*xAlt*xAlt; xNeuF = (float)xNeu;
     yNeu = c2*xAlt; yNeuF = (float)yNeu;
     xK = round( map(xNeuF,xU,xO,0,w));                 
     yK = round (map(yNeuF,yU,yO,h,0));          
     stroke(farben[j]); 
     point(xK,yK);   
     xAlt = xNeu;
     yAlt = yNeu;
     i++;
   }
   i=0;  
}
///////////////////////////////////////////////////////////
void tastenEinstellungen(){
   rectMode(CENTER);
   font = createFont("Arial",20);
   textSize(24);  
   String s = "FncdR";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false; 
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
////////////////////////////////////////////////////////////////
void tastenZeichnen(){
  tastenWechsel=true;
  fill(0,0,100);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(255,255,0));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);     
  }   
}
